import numpy as np
import pylab as pl
import scipy as sp
from scipy import linalg,random
import methodes as met



# Exercice 2
Y=np.random.rand(4,4)
Z=met.orthonorm(Y)
test1=abs(np.linalg.matrix_rank(Z)-np.linalg.matrix_rank(Y))
test2=sp.linalg.norm(np.dot(Z.T,Z)-np.eye(4))
print('Erreur sur le rang: ',test1)
print('Défaut d''orthogonalité: ',test2)

A=sp.random.rand(4,4)
R=A.copy()
u=met.householder(R[0:,0])
u.shape=(4,1)
H1=np.eye(4)-2*np.dot(u,u.T)
a=A[0:,0]
a.shape=(4,1)
c=np.dot(H1,a)
c.shape=(4,)
B=np.zeros(shape=(4,4))
B[0:,0]=c
print(B)

#
A=10*sp.random.rand(4,4)
R=A.copy()
u=met.householder(R[0:,0])
u.shape=(4,1)
H1=np.eye(4)-2*np.dot(u,u.T)
B=np.zeros(shape=(4,4))
for j in range(4):
    a=A[0:,j]
    a.shape=(4,1)
    c=np.dot(H1,a)
    c.shape=(4,)
    B[0:,j]=c
print(B)
H=H1.copy()

R=B.copy()
u=met.householder(R[1:,1])
u.shape=(3,1)
tH2=np.eye(3)-2*np.dot(u,u.T)
H2=np.zeros(shape=(4,4))
H2[0,0]=1
H2[1:,1:]=tH2
C=np.zeros(shape=(4,4))
for j in range(4):
    a=B[0:,j]
    a.shape=(4,1)
    c=np.dot(H2,a)
    c.shape=(4,)
    C[0:,j]=c
print(C)
H=np.dot(H2,H)

R=C.copy()
u=met.householder(R[2:,2])
u.shape=(2,1)
tH3=np.eye(2)-2*np.dot(u,u.T)
H3=np.zeros(shape=(4,4))
H3[0,0]=1
H3[1,1]=1
H3[2:,2:]=tH3
R=np.zeros(shape=(4,4))
for j in range(4):
    a=C[0:,j]
    a.shape=(4,1)
    c=np.dot(H3,a)
    c.shape=(4,)
    R[0:,j]=c
print(R)
H=np.dot(H3,H)

s=0
for j in range(3):
    s += sp.linalg.norm(R[j+1:,j])
print(s)

Q=H.T
E=np.dot(Q,R)
verif=sp.linalg.norm(E-A)
print(verif)

E=np.dot(Q.T,Q)
verif=sp.linalg.norm(E-np.eye(4))
print(verif)

E=np.dot(Q,Q.T)
verif=sp.linalg.norm(E-np.eye(4))
print(verif)

#
A=10*sp.random.rand(4,4)
Q,R=met.qr_householder(A)

s=0
for j in range(3):
    s += sp.linalg.norm(R[j+1:,j])
print(s)

E=np.dot(Q,R)
verif=sp.linalg.norm(E-A)
print(verif)

E=np.dot(Q.T,Q)
verif=sp.linalg.norm(E-np.eye(4))
print(verif)

E=np.dot(Q,Q.T)
verif=sp.linalg.norm(E-np.eye(4))
print(verif)

#
A=10*sp.random.rand(4,5)
Q,R=met.qr_householder(A)

s=0
for j in range(3):
    s += sp.linalg.norm(R[j+1:,j])
print(s)

E=np.dot(Q,R)
verif=sp.linalg.norm(E-A)
print(verif)

E=np.dot(Q.T,Q)
verif=sp.linalg.norm(E-np.eye(4))
print(verif)

E=np.dot(Q,Q.T)
verif=sp.linalg.norm(E-np.eye(4))
print(verif)


#
A=10*sp.random.rand(5,4)
Q,R=met.qr_householder(A)

s=0
for j in range(3):
    s += sp.linalg.norm(R[j+1:,j])
print(s)

E=np.dot(Q,R)
verif=sp.linalg.norm(E-A)
print(verif)

E=np.dot(Q.T,Q)
verif=sp.linalg.norm(E-np.eye(5))
print(verif)

E=np.dot(Q,Q.T)
verif=sp.linalg.norm(E-np.eye(5))
print(verif)


##
A=sp.random.rand(20,15)
z=met.orthonorm(A)
Q,R=met.qr_householder(A)


for j in range(14):
    s += sp.linalg.norm(R[j+1:,j])
print(s)

E=np.dot(Q,R)
verif=sp.linalg.norm(E-A)
print(verif)

E=np.dot(Q.T,Q)
verif=sp.linalg.norm(E-np.eye(20))
print(verif)

E=np.dot(Q,Q.T)
verif=sp.linalg.norm(E-np.eye(20))
print(verif)

verif=sp.linalg.norm(z-Q[:,:15])
print(verif)

