import numpy as np
import pylab as pl
import scipy as sp
from scipy import linalg,random
import methodes as met

N=20 #50 #20


n=5
J=np.tril(np.ones(shape=(n,n)))
J -= J.T
J=J/2
U=sp.linalg.expm(J)
A=np.dot(np.dot(U,np.diag(100*0.9**(np.arange(1,n+1)))),U.T)

A0=A.copy()
x0,nu0=met.puissance(A0,N)

print(nu0)

#
A0=np.diag([-2,1,1])
x1,nu1=met.puissance(A0,N)
x0,nu0=met.puissance_m(A0,N)

print(nu1)
print(nu0)


#
A0=np.diag([-2,-2,1])
x1,nu1=met.puissance(A0,N)
x0,nu0=met.puissance_m(A0,N)

print(nu1)
print(nu0)

#
A0=np.array([[2,1,0],[0,2,0],[0,0,1]])
x1,nu1=met.puissance(A0,N)
x0,nu0=met.puissance_m(A0,N)

print(nu1)
print(nu0)


#
A0=np.array([[2,0,0],[0,1,1],[0,0,1]])
x1,nu1=met.puissance(A0,N)
x0,nu0=met.puissance_m(A0,N)

print(nu1)
print(nu0)

##
N=100 #20 #50 #20

n=40
J=np.tril(np.ones(shape=(n,n)))
J -= J.T
J=J/2
U=sp.linalg.expm(J)
A=np.dot(np.dot(U,np.diag(100*0.9**(np.arange(1,n+1)))),U.T)

x1,nu1=met.puissance(A,N)
x0,nu0=met.puissance_m(A,N)

print(nu1)
print(nu0)

verif=sp.linalg.norm(np.diag(nu0)-100*0.9**(np.arange(1,n+1)))
print(verif)

#
A0=np.diag([-2,2,1])
N=100
x1,nu1=met.puissance(A0,N)
x0,nu0=met.puissance_m(A0,N)

print(nu1)
print(nu0)

#
n=5
A=np.eye(n)-np.diag(np.ones(n-1),-1)
A += A.T
x1,nu1=met.puissance(A,N)
x0,nu0=met.puissance_m(A,N)
verif=sp.linalg.norm(np.diag(np.diag(nu0))-nu0)
print(verif)
print('Valeurs propres du pb de  la chaleur: ',np.diag(nu0))
