import numpy as np
import pylab as pl
import scipy as sp
from scipy import linalg,random
import methodes as met

it=100
n=40
J=np.tril(np.ones(shape=(n,n)))
J -= J.T
J=J/2
U=sp.linalg.expm(J)
A=np.dot(U,np.dot(np.diag(100*0.9**(np.arange(1,n+1))),U.T))
Q,R,taberr=met.QRval(A,it)
print(taberr[-1])

taberrf=taberr[10:]
taberrf=np.log(taberrf)
tabiter=np.arange(it)
tabiterf=tabiter[10:]
tabiterf=np.log(tabiterf)
pente=[(taberrf[i+1]-taberrf[i])/(tabiter[i+1]-tabiter[i]) for i in range(len(taberrf)-1)]
print(min(pente),max(pente))

verif=sp.linalg.norm(100*0.9**(np.arange(1,n+1))-np.diag(R).T)
print(verif)
pl.plot(tabiterf,taberrf,linewidth=0.5,color='black')
pl.show()
pl.close()


#
eps=10*(-3)
Q,R,taberr,it=met.QRval_eps(A,eps)
print(taberr[it])

taberrf=taberr[10:]
taberrf=np.log(taberrf)
tabiter=np.arange(it+1)
tabiterf=tabiter[10:]
tabiterf=np.log(tabiterf)
pente=[(taberrf[i+1]-taberrf[i])/(tabiter[i+1]-tabiter[i]) for i in range(len(taberrf)-1)]
print(min(pente),max(pente))

verif=sp.linalg.norm(100*0.9**(np.arange(1,n+1))-np.diag(R).T)
print(verif)
pl.plot(tabiterf,taberrf,linewidth=0.5,color='black')
pl.show()
pl.close()
