import numpy as np
import pylab as pl
import scipy as sp
from scipy import linalg

# Exercice 1

#1

eps=10**(-2)
N=20 #10

A0=np.diag([-2,1,1])
x0=2*np.random.rand(3,1)
x0 -= np.ones(shape=(3,1))

x=x0.copy()


for k in range(N):
    y=np.dot(A0,x)
    nu=np.dot(x.T,y)
    x=y/sp.linalg.norm(y)

errl=abs(nu+2)
erry=sp.linalg.norm(x[1:])
print('Erreur sur la plus grande valeur propre: ',errl)
print('Erreur sur le vecteur propre associé: ',erry)
    
#2

A0=np.diag([-2,-2,1])
x0=2*np.random.rand(3,1)
x0 -= np.ones(shape=(3,1))


x=x0.copy()

for k in range(N):
    y=np.dot(A0,x)
    nu=np.dot(x.T,y)
    x=y/sp.linalg.norm(y)

errl=abs(nu+2)
erry=sp.linalg.norm(x[-1])
print('Erreur sur la plus grande valeur propre: ',errl)
print('Erreur sur le vecteur propre associé: ',erry)

#3

A0=np.diag([-2,2,1])
x0=2*np.random.rand(3,1)
x0 -= np.ones(shape=(3,1))

tabN=np.arange(10,101,10)

i=0
taberrl=np.zeros(len(tabN))
taberry=np.zeros(len(tabN))
taberr=np.zeros(len(tabN))
for N in tabN:
    x=x0.copy()
    for k in range(N):
        y=np.dot(A0,x)
        nu=np.dot(x.T,y)
        x=y/sp.linalg.norm(y)
    errl=abs(nu**2-4)
    erry=abs(x[-1]) #sp.linalg.norm(x[-1])
    taberrl[i]=errl
    taberry[i]=erry
    taberr[i]=errl+erry
    i += 1
    
print('Erreur sur la plus grande valeur propre: ',taberrl)
print('Erreur sur le vecteur propre associé: ',taberry)
print('Erreur sur le premier élément propre: ',taberr)

pl.plot(tabN,taberrl,linewidth=0.5,color='black')
pl.show()
pl.close()

pl.plot(tabN,taberry,linewidth=0.5,color='black')
pl.show()
pl.close()

#4

A0=[[2,1,0],[0,2,0],[0,0,1]]
A0=np.array(A0)
x0=2*np.random.rand(3,1)
x0 -= np.ones(shape=(3,1))

tabN=np.arange(10,101,10)

i=0
taberrl=np.zeros(len(tabN))
taberry=np.zeros(len(tabN))
taberr=np.zeros(len(tabN))
for N in tabN:
    x=x0.copy()
    for k in range(N):
        y=np.dot(A0,x)
        nu=np.dot(x.T,y)
        x=y/sp.linalg.norm(y)
    errl=abs(nu-2)
    erry=abs(x[-1]) #sp.linalg.norm(x[-1])
    taberrl[i]=errl
    taberry[i]=erry
    taberr[i]=errl+erry
    i += 1
    
print('Erreur sur la plus grande valeur propre: ',taberrl)
print('Erreur sur le vecteur propre associé: ',taberry)
print('Erreur sur le premier élément propre: ',taberr)

pl.plot(tabN,taberr,linewidth=0.5,color='black')
pl.show()
pl.close()

#5

A0=[[2,0,0],[0,1,1],[0,0,1]]
A0=np.array(A0)
x0=2*np.random.rand(3,1)
x0 -= np.ones(shape=(3,1))

tabN=np.arange(10,101,10)

i=0
taberrl=np.zeros(len(tabN))
taberry=np.zeros(len(tabN))
taberr=np.zeros(len(tabN))
for N in tabN:
    x=x0.copy()
    for k in range(N):
        y=np.dot(A0,x)
        nu=np.dot(x.T,y)
        x=y/sp.linalg.norm(y)
    errl=abs(nu-2)
    erry=sp.linalg.norm(np.dot(A0,x)-2*x) #sp.linalg.norm(x[:1])
    taberrl[i]=errl
    taberry[i]=erry
    taberr[i]=errl+erry
    i += 1
    
print('Erreur sur la plus grande valeur propre: ',taberrl)
print('Erreur sur le vecteur propre associé: ',taberry)
print('Erreur sur le premier élément propre: ',taberr)

pl.plot(tabN,taberrl,linewidth=0.5,color='black')
pl.show()
pl.close()

pl.plot(tabN,taberry,linewidth=0.5,color='black')
pl.show()
pl.close()


